// Sample2_SWF_FLV_EmbeddingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Sample2_SWF_FLV_Embedding.h"
#include "Sample2_SWF_FLV_EmbeddingDlg.h"
#include ".\sample2_swf_flv_embeddingdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CSample2_SWF_FLV_EmbeddingDlg dialog



CSample2_SWF_FLV_EmbeddingDlg::CSample2_SWF_FLV_EmbeddingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSample2_SWF_FLV_EmbeddingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSample2_SWF_FLV_EmbeddingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CSample2_SWF_FLV_EmbeddingDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(ID_PLAY_EMBEDDED_SWF, OnBnClickedPlayEmbeddedSwf)
	ON_BN_CLICKED(ID_PLAY_EMBEDDED_FLV, OnBnClickedPlayEmbeddedFlv)
	ON_BN_CLICKED(IDC_CHECK_STANDARD_MENU, OnBnClickedCheckStandardMenu)
	ON_BN_CLICKED(IDC_CHECK_SOUNDS, OnBnClickedCheckSounds)
	ON_BN_CLICKED(ID_SITE, OnBnClickedSite)
	ON_BN_CLICKED(ID_ORDER, OnBnClickedOrder)
END_MESSAGE_MAP()


// CSample2_SWF_FLV_EmbeddingDlg message handlers

static HRESULT WINAPI GlobalOnLoadExternalResourceHandler(LPCSTR lpszURL, IStream** ppStream);

BOOL CSample2_SWF_FLV_EmbeddingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	// FlashPlayerControl creating
	// NOTE: CALL RegisterFlashWindowClass() or RegisterFlashWindowClassEx() before creating!
	// See InitInstance() implementation
	{
		RECT rc;
		GetDlgItem(IDC_STATIC_FPC_PLACE)->GetWindowRect(&rc);
		ScreenToClient(&rc);

		m_hwndFlashPlayerControl = 
			CreateWindow(WC_FLASH, 
						 NULL, 
						 WS_CHILD | WS_VISIBLE, 
						 rc.left, 
						 rc.top, 
						 rc.right - rc.left, 
						 rc.bottom - rc.top, 
						 m_hWnd, 
						 NULL, 
						 NULL, 
						 NULL);
	}

	// Loading movie
	{
		TCHAR lpszMoviePath[_MAX_PATH + 1] = { 0 };
		GetModuleFileName(NULL, lpszMoviePath, _MAX_PATH);
		
		for (int nIndex = lstrlen(lpszMoviePath) - 1; nIndex >= 0; nIndex--)
			if (_T('\\') == lpszMoviePath[nIndex])
			{
				lpszMoviePath[nIndex] = 0;
				break;
			}
		lstrcat(lpszMoviePath, _T("\\movie.swf"));

		SFPCPutMovie FPCPutMovie;
		FPCPutMovie.lpszBuffer = lpszMoviePath;
		::SendMessage(m_hwndFlashPlayerControl, FPCM_PUT_MOVIE, 0, (LPARAM)&FPCPutMovie);
	}

	CheckDlgButton(IDC_CHECK_SOUNDS, BST_CHECKED);

	FPCSetGlobalOnLoadExternalResourceHandler(&GlobalOnLoadExternalResourceHandler);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CSample2_SWF_FLV_EmbeddingDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSample2_SWF_FLV_EmbeddingDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSample2_SWF_FLV_EmbeddingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

HRESULT WINAPI GlobalOnLoadExternalResourceHandler(LPCSTR lpszURL, IStream** ppStream)
{
	HRESULT hr = E_FAIL;

	if (0 == lstrcmpiA(lpszURL, "http://FLV/FlashVideo.flv"))
	{
		// Create stream
		IStream* pMemStream = NULL;
		CreateStreamOnHGlobal(NULL, TRUE, &pMemStream);

		// Save flash video to the stream from the resource
		HMODULE hModule = GetModuleHandle(NULL);
		HRSRC hResInfo = FindResource(hModule, _T("EMBEDDED_FLV"), _T("FLV"));
		HGLOBAL hResData = LoadResource(hModule, hResInfo);
		LPCVOID lpData = LockResource(hResData);
		DWORD dwSize = SizeofResource(hModule, hResInfo);

		ULONG nWritten;
		pMemStream->Write(lpData, dwSize, &nWritten);

		// Seek stream position to the begin
		LARGE_INTEGER liZero = { 0 };
		ULARGE_INTEGER ulNewPosition;
		pMemStream->Seek(liZero, STREAM_SEEK_SET, &ulNewPosition);

		*ppStream = pMemStream;
		hr = S_OK;
	}

	return hr;
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedPlayEmbeddedSwf()
{
	HMODULE hModule = GetModuleHandle(NULL);
	HRSRC hResInfo = FindResource(hModule, _T("MOVIE"), _T("SWF"));
	HGLOBAL hResData = LoadResource(hModule, hResInfo);
	LPVOID lpData = LockResource(hResData);
	DWORD dwSize = SizeofResource(hModule, hResInfo);

	SFPCPutMovieFromMemory FPCPutMovieFromMemory;
	FPCPutMovieFromMemory.lpData = lpData;
	FPCPutMovieFromMemory.dwSize = dwSize;

	::SendMessage(m_hwndFlashPlayerControl, FPCM_PUTMOVIEFROMMEMORY, 0, (LPARAM)&FPCPutMovieFromMemory);
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedPlayEmbeddedFlv()
{
	HMODULE hModule = GetModuleHandle(NULL);
	HRSRC hResInfo = FindResource(hModule, _T("FLVPlayer"), _T("SWF"));
	HGLOBAL hResData = LoadResource(hModule, hResInfo);
	LPVOID lpData = LockResource(hResData);
	DWORD dwSize = SizeofResource(hModule, hResInfo);

	SFPCPutMovieFromMemory FPCPutMovieFromMemory;
	FPCPutMovieFromMemory.lpData = lpData;
	FPCPutMovieFromMemory.dwSize = dwSize;

	::SendMessage(m_hwndFlashPlayerControl, FPCM_PUTMOVIEFROMMEMORY, 0, (LPARAM)&FPCPutMovieFromMemory);
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedCheckStandardMenu()
{
	SFPCPutStandartMenu FPCPutStandartMenu;
	FPCPutStandartMenu.StandartMenu = IsDlgButtonChecked(IDC_CHECK_STANDARD_MENU);
	::SendMessage(m_hwndFlashPlayerControl, FPCM_PUT_STANDART_MENU, 0, (LPARAM)&FPCPutStandartMenu);
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedCheckSounds()
{
	if (IsDlgButtonChecked(IDC_CHECK_SOUNDS))
		FPCSetAudioEnabled(TRUE);
	else
		FPCSetAudioEnabled(FALSE);
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedSite()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/"), NULL, NULL, SW_SHOW);
}

void CSample2_SWF_FLV_EmbeddingDlg::OnBnClickedOrder()
{
	ShellExecute(m_hWnd, NULL, _T("http://www.flashplayercontrol.com/dll/order.html"), NULL, NULL, SW_SHOW);
}
